
#include <xc.h>
#include <stdint.h>
#include "ir.h"
#include "config.h"

void irRx(void){
    // 受信処理 -------------
    static uint8_t num;         // 受信Bit数を計測
    static uint16_t IrData;     // 受信データを蓄積
    uint16_t timeIntvl = TMR1;  // データ間隔
    TMR1 = 0;                   // 次の間隔測定のため
    // ステート制御 *****************************************************
    switch(irState){              
        case leaderStart:           // leader Mark 開始時 ⥥ -------
            TMR1ON = 1;                 // Timer1 ON
            TMR1IF = 0;
            if(!IrIN)                   // Markなら
                irState = leaderMkEnd;  // leader Mark 終了 待ちへ
            break;
        case leaderMkEnd:           // leader Mark 終了 ⥣ ----------
            if(timeIntvl > L_ON_Min)    // リーダー最小継続を超えるなら
                irState = dataStart;    //   data Mark 開始　待ちへ
            else                        // 最小継続　未満なら
                irState = leaderStart;  // Leaderを待つ
            break;
        case dataStart:             // data Mark 開始時 ⥥ ------------
            num = 16;                   // 受信Bit数リセット
            IrData = 0;                 // 受信dataリセット
            irState = dataMkEnd;        // data Mark 終了 待ちへ
            break;
        case dataMkEnd:             // data Mark 終了 ⥣ ------------
            irState = dataBitEnd;       // data Bit 終了 待ちへ
            break;
        case dataBitEnd:            // data Bit 終了 ⥥ ------------
            if(timeIntvl > DataTH)      // スペース時間で「1」「０」判定
                IrData |= 1;            //   長ければ「1」
            num--;                      // 受信Bit数の確認
            if(num){                    // 途中なら
                IrData <<= 1;           //   次 Bitの準備
                irState = dataMkEnd;    //   次 data bit 受信へ
            }else{                      // 終了なら
                revdData = IrData;      //   結果を保存
                irState = leaderStart;  // Leaderを待つ
            }
            break;
        default:                    // 予定外 ------------
             irState = leaderStart;
            break; 
    }
}
