#include <xc.h>
#include <stdint.h>
#include <stdlib.h>

#ifndef  _XTAL_FREQ
#define _XTAL_FREQ 8000000
#endif

// LED点滅パターン設定 
const uint8_t LEDptn[7][8] = {
    {5,0b0000,0b1000,0b0100,0b0010,0b0001,0,0},
    {6,0b0000,0b1000,0b1100,0b0110,0b0011,0b0001,0},
    {4,0b0000,0b1001,0b1111,0b0110,0,0,0},
    {2,0b1001,0b0110,0,0,0,0,0},
    {2,0b1010,0b0101,0,0,0,0,0}
};
// box mode --------------
#define mSong   0
#define mSteady 1
#define mFlash  2
#define mRandum 3

#define inc 1
#define dec 0

// 共通変数 ************************************************
uint8_t ptnNum = 0;         // パターン番号
uint8_t ptnIdx = 1;         // パターン位置
uint8_t ptnDir = 0;         // パターン方向
int16_t onTh = 15000;         // パターン方向

extern uint8_t boxMode;        // 0:Song 1:Steady 2:Flash 3:Randum

void modeLED(void);
void led_isr(void);
void flash(uint8_t);
void steady(uint8_t);
void random(void);
void speed(uint8_t);
void dir(uint8_t);
