/* 
 * File:   song.h
 * Author: ki
 *
 * Created on November 2, 2017, 2:07 PM
 */
#include<xc.h>
#ifndef  _XTAL_FREQ
#define _XTAL_FREQ 8000000
#endif

// 共通変数 ************************************************
extern uint16_t revdData;

// オルゴールステート名 ************************************
#define waitStart  0
#define getGakufu  1
#define getOnpu    2
#define onpuEnd    3
#define gkfEnd     4

#define playEnd     CCP3IF          // 音符演奏終了フラグ
#define playLen     CCPR3           // 音符演奏の長さ
#define playCnt     TMR3            // 演奏経過時間カウント
#define volume      CCPR1L          // 音量 00-FF
#define reduceFlg   CCP4IF          // 音量減衰フラグ
#define musicOn()   LC4EN=1
#define musicOff()  LC4EN=0


// 音の高さを決める定数  for NOC clock 250KHz
const uint16_t dW_tbl[] = {
//  Do,   Do#,  Re,   Re#,  Mi,   Fa,   Fa#,  So,   So#,  Ra,   Ra#,  Si,
  0,0x112,0x122,0x133,0x146,0x159,0x16E,0x183,0x19B,0x1B3,0x1CD,0x1E8,0x205, //12
    0x224,0x245,0x267,0x28C,0x2B3,0x2DC,0x307,0x336,0x366,0x39A,0x3D1,0x40B,
    0x449,0x48A,0x4CF,0x518,0x566,0x5B8,0x60F,0x66C,0x6CD,0x735,0x7A3,0x817,
    0x892,0x915,0x99F,0xA31,0xACD,0xB71,0xC1F,0xCD8,0xD9B,0xE6A,0xF46,0x102E,
    0x1125,0x122A,0x133E,0x1463,0x159A,0x16E3,0x183F,0x19B0,0x1B37,0x1CD5,0x1E8C,0x205D,
    0x224A,0x2454,0x267D,0x28C7,0x2B34,0x2DC6,0x307E,0x3361,0x366F,0x39AB,0x3D19,0x40BB
};  // 0x892(index 37) が中心のド(60 0x3E) ,0xD9B はラ (440Hz)


// プロトタイプ ************************************************
void modeSong(void);
void playSong(uint8_t);
